var isArray = require('./index80.js');
var _setup = require('./index24.js');
var isString = require('./index100.js');
var _isArrayLike = require('./index21.js');
var map = require('./index108.js');
var identity = require('./index71.js');
var values = require('./index157.js');

// Safely create a real, live array from anything iterable.
var reStrSymbol = /[^\ud800-\udfff]|[\ud800-\udbff][\udc00-\udfff]|[\ud800-\udfff]/g;
function toArray(obj) {
  if (!obj) return [];
  if (isArray(obj)) return _setup.slice.call(obj);
  if (isString(obj)) {
    // Keep surrogate pair characters together.
    return obj.match(reStrSymbol);
  }
  if (_isArrayLike(obj)) return map(obj, identity);
  return values(obj);
}

module.exports = toArray;
