var _getLength = require('./index17.js');
var isArray = require('./index80.js');
var isString = require('./index100.js');
var isArguments = require('./index78.js');
var keys = require('./index106.js');

// Is a given array, string, or object empty?
// An "empty" object has no enumerable own-properties.
function isEmpty(obj) {
  if (obj == null) return true;
  // Skip the more expensive `toString`-based type checks if `obj` has no
  // `.length`.
  var length = _getLength(obj);
  if (typeof length == 'number' && (
    isArray(obj) || isString(obj) || isArguments(obj)
  )) return length === 0;
  return _getLength(keys(obj)) === 0;
}

module.exports = isEmpty;
